/*
 * spi_master.cpp
 *
 *  Created on: 06.03.2012
 *      Author: Felix Adam
 */

#ifndef _SPI_MASTER_H_
#define _SPI_MASTER_H_



#include <avr/io.h>
#include <inttypes.h>
#include <stdbool.h>
#include <stdlib.h>



class SpiMaster
{
  public:

    SpiMaster(SPI_t* _spi, SPI_INTLVL_t _int_level);
    //~SpiMaster();

    
    void   config(SPI_MODE_t _spi_mode, SPI_PRESCALER_t _spi_prescaler, uint8_t _dummy_byte);
  
    void   setBuffer(uint8_t* _ptr_tx_buffer, uint8_t* _ptr_rx_buffer, volatile bool* _active_ptr);

    void   readMisoLevel(PORT_t* _cs_port, uint8_t _cs_pin, bool* _level);

    void   startTransfer(uint8_t _tx_size, uint8_t _rx_size, uint8_t _rx_begin, PORT_t* _cs_port, uint8_t _cs_pin);

    bool   active(void);

    void   handler(void);
    

  private:
    SPI_t*           spi;
    PORT_t*          cs_port;
    uint8_t          cs_pin;
    bool             spi_active;
	volatile bool*	 active_ptr;
    uint8_t*         ptr_tx_buffer;
    uint8_t*         ptr_rx_buffer;
    // Pointers to actual position in buffers
    uint8_t          tx_pointer;
    uint8_t          rx_pointer;
    uint8_t          tx_size;
    uint8_t          rx_size;
    uint8_t          rx_begin;

    bool             result;

    uint8_t          dummy_byte;
};



#endif
