#ifndef _TIMER_H_
#define _TIMER_H_


#include <avr/io.h>
#include <inttypes.h>
#include <stdbool.h>
#include <stdlib.h>


#define TIMER_MAX_SLOTS       ((uint8_t)(10))




class Timer
{

  public:
    Timer(TC1_t* _timer, TC_CLKSEL_t _clock_prescaler, uint16_t _period, uint8_t _timers, TC_OVFINTLVL_t _int_level);
    //~TimerInterrupts();

    void   timerSet(uint8_t _timer_slot, uint16_t _time);
    bool   timerGet(uint8_t _timer_slot);
    void   timerEnable(bool _enable);

    void   handler(void);


  private:
    bool               result;
    TC_CLKSEL_t        clock_prescaler;
    uint8_t            timer_index;
    uint8_t            timers;
    uint8_t            change_protect;
    uint16_t           timer_values[TIMER_MAX_SLOTS];
    TC1_t*             timer;
    uint16_t           period;
    
};


#endif
